;===============================================================================
;
;CHARACTER STRING MANIPULATION LIBRARY MACROS
;
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                                                                             *
;* Copyright 2015 by William J Brier                                          *
;*                                                                             *
;* Redistribution & use of this software in source and/or binary forms, with   *
;* or without modification, are permitted, provided that the following terms & *
;* conditions are met:                                                         *
;*                                                                             *
;* 1) Redistributions of source code must retain the above copyright notice,   *
;*    this list of conditions & the below disclaimer.                          *
;*                                                                             *
;* 2) Redistribution in binary form must reproduce the above copyright notice, *
;*    this list of conditions & the below disclaimer in the documentation &    *
;*    other materials included with the distribution.                          *
;*                                                                             *
;* 3) The names of the copyright holder and/or its contributors may not be     *
;*    used to endorse or promote products derived from this software without   *
;*    specific prior written permission.                                       *
;*                                                                             *
;* DISCLAIMER                                                                  *
;*                                                                   *
;* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS & CONTRIBUTORS AS IS.  *
;* Any express or implied warranties, including, but not limited to, the imp-  *
;* lied warranties of merchantability & fitness for a particular purpose are   *
;* disclaimed.  In no event shall the copyright owner and/or contributors be   *
;* liable for any direct, indirect, incidental, special, exemplary, or conse-  *
;* quential damages (including, but not limited to, procurement of substitute  *
;* goods or services; loss of use, data, or profits; or business interruption) *
;* however caused & on any theory of liability, whether in contract, strict    *
;* liability, or tort (including negligence or otherwise) arising in any way   *
;* out of the use of this software, even if advised of the possibility of such *
;* damage.                                                                     *
;*                                                                             *
;* If any provision set forth herein is not acceptable to you, DO NOT USE THIS *
;* SOFTWARE & immediately delete it from your system.                          *
;*                                                                             *
;* Macro invocation details are located at the end of this file.               *
;*                                                                             *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;
strcat	.macro ...               ;catenate string S2 to string S1
.rp      =4
	.if @0 == .rp
.np          = .rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strcat
	.else
         per *+5
         brl strcat
	.endif
         .endm
;
strchr	.macro ...               ;find char C in string S
.rp      =4
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strchr
	.else
         per *+5
         brl strchr
	.endif
         .endm
;
strcmp	.macro ...               ;compare string S2 to string S1
.rp      =4
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strcmp
	.else
         per *+5
         brl strcmp
	.endif
         .endm
;
strcpy	.macro ...               ;copy string S2 to string S1
.rp      =4
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strcpy
	.else
         per *+5
         brl strcpy
	.endif
         .endm
;
strdel	.macro ...               ;delete N chars from string S at index I
.rp      =6
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strdel
	.else
         per *+5
         brl strdel
	.endif
         .endm
;
strins	.macro ...               ;insert string S2 into string S1 at I
.rp      =6
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strins
	.else
         per *+5
         brl strins
	.endif
         .endm
;
strlen	.macro .s,.a             ;get printable length of string S
.mode    = {.a | %00100000}
	.if .mode == 'd'
	    .if .s > $fc
	        .error ""+@0$+": 'DP' address out of range"
	    .endif
         pei .s+2
         pei .s
	.else
	    .if .mode == 'f'
	        .if {.s >> 16} > $ff
	            .error ""+@0$+": 'far' address out of range"
	        .endif
         pea #.s >> 16
         pea #.s & $ffff
	    .else
	        .if .mode == 'n'
	            .rept 2
         phk
	            .endr
         per .s & $ffff
	        .else
	            .if .mode == 'r'
	rep #%00010000
	phy
	phx
	            .else
	                .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	            .endif
	        .endif
	    .endif
	.endif
	.if .def(_STRLIB_)
         jsl strlen
	.else
         per *+5
         brl strlen
	.endif
         .endm
;
strpad	.macro ...               ;copy string S2 to string S1 w/padding
.rp      =8
	.if @0 == .rp
.fp          =2
.pp          =.rp-.fp
.np          =.pp/2
.ct          .=.rp
	    .rept .fp
                 pea #@.ct
.ct              .=.ct-1
	    .endr
.ct          .=.np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strpad
	.else
         per *+5
         brl strpad
	.endif
         .endm
;
strpat	.macro ...               ;compare pattern P to string S
.rp      =4
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strpat
	.else
         per *+5
         brl strpat
	.endif
         .endm
;
strstr	.macro ...               ;search for string S2 in string S1
.rp      =4
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strstr
	.else
         per *+5
         brl strstr
	.endif
         .endm
;
strsub	.macro ...               ;copy N bytes from byte I in string S2 to string S1
.rp      =8
	.if @0 == .rp
.np          =.rp/2
.ct          .= .np
	    .rept .ct
.mode            .= {@{.ct+.np} | %00100000}
	        .if .mode == 'd'
	            .if {@.ct} > $fc
	                .error ""+@0$+": 'DP' address out of range"
	            .endif
         pei {@.ct}+2
         pei {@.ct}
	        .else
	            .if .mode == 'f'
	                .if {{@.ct} >> 16} > $ff
	                    .error ""+@0$+": 'far' address out of range"
	                .endif
         pea #{@.ct} >> 16
         pea #{@.ct} & $ffff
	            .else
	                .if .mode == 'n'
	                    .rept 2
         phk
	                    .endr
         per {@.ct} & $ffff
	                .else
	                    .error ""+@0$+": mode must be 'd', 'f' or 'n'"
	                .endif
	            .endif
	        .endif
.ct              .= .ct-1
	    .endr
	.else
	    .error ""+@0$+": missing parameters"
	.endif
	.if .def(_STRLIB_)
         jsl strsub
	.else
         per *+5
         brl strsub
	.endif
         .endm
;
strsws	.macro .s,.o,.a          ;strip whitespace from string S
.mode    = {.a | %00100000}
         pea #.o
	.if .mode == 'd'
	    .if .s > $fc
	        .error ""+@0$+": 'DP' address out of range"
	    .endif
         pei .s+2
         pei .s
	.else
	    .if .mode == 'f'
	        .if {.s >> 16} > $ff
	            .error ""+@0$+": 'far' address out of range"
	        .endif
         pea #.s >> 16
         pea #.s & $ffff
	    .else
	        .if .mode == 'n'
	            .rept 2
         phk
	            .endr
         per .s & $ffff
	        .else
	            .if .mode == 'r'
	rep #%00010000
	phy
	phx
	            .else
	                .error ""+@0$+": mode must be 'd', 'f', 'n' or 'r'"
	            .endif
	        .endif
	    .endif
	.endif
	.if .def(_STRLIB_)
         jsl strsws
	.else
         per *+5
         brl strsws
	.endif
         .endm
;
;
;	macro call constants  do not edit
;
_JUSTLFT =0                    ;left justification
_JUSTRIT =1                    ;right justification
_JUSTCTR =2                    ;center justification
_LSTRIP  =%01000000            ;leading strip
_TSTRIP  =%10000000            ;trailing strip
_FSTRIP  =_TSTRIP|_LSTRIP      ;leading & trailing strip
;
	.end
;===============================================================================

MACRO INVOCATION NOTES


String library calls receive data via a  stack frame.  The 2 data types used  to
make up a  stack frame are  a 32-bit pointer  to an object  & a 16-bit  integer,
which is  a value.   Macro invocations  provide a  way to  tell the macro how to
process parameters.

In the following discussion, notation such as *S means the address of object  S.
*S could be a literal address, the  address of a location in memory (a  pointer)
at which Ss address may be found or could represent an address loaded into  the
microprocessors registers.

As  the  65C816  generates  24-bit  addresses  regardless  of  an  instructions
addressing mode, the most-significant  byte (MSB) of *Ss  most-significant word
(MSW) is not computationally relevant.  However, processing addresses as  32-bit
quantities at the assembly language level is more efficient than processing them
as 24 bits quantities.  For that reason, macros treat all addresses required  by
their associated functions as 32-bit, little-endian quantities.

Macros are able to resolve addresses in several ways, the method used  depending
on the value  of a single-character,  case-insensitive flag.  Since  most macros
accept  multiple parameters,  multiple flags  are used  to produce  fine-grained
control.

The simplest form of a macro invocation is:

    <macro> *S,A

In the above example, *S points to object S.   A is the mode flag that tells the
macro how to interpret *S.  Possible mode flag values are:

    'd': DP (direct page) pointer:

         *S is  a DP  location at  which Ss  32-bit address  is stored  in four
         contiguous bytes.   *S+3 should contain $00.

    'f': Far address:

         *S is Ss 32-bit address.  *S is referred to as a far address,  since
         it can refer to anywhere in the 65C816s address space.

    'n': Near address:

         *S is  the least-significant  word (LSW) of Ss  32-bit address.  *S is
         referred to  as a  near address  because the  MSW of  Ss address  is
         assumed  to   be   the   bank  in    which  the   calling   program  is
         executinghence S is near the caller.  If the caller is executing in
         bank $AB & the LSW of Ss address is $1234, Ss effective address  will
         be $00AB1234.

    'r': Register pointer.

         Ss address is in the X & Y registers, with the LSW in the X &  the MSW
         in the Y register.  The index registers must be set to 16 bits in order
         to be able to pass a 32-bit address.  As a precaution, if this  addres-
         sing method is selected when a macro is invoked, a  REP #%00010000  in-
         struction will be executed to  prevent  stack  corruption.  Only macros
         that accept a single pointer can be invoked with the r mode.

For a somewhat more complex case, consider the following:

    strpad *S1,*S2,*L,A1,A2,AL,J,FB

This function pads &  justifies string   S2 to  length L, placing the  result in
string  S1.  In  the above  example,  J & FB  are  values  that are  treated  as
assembly-time constants.  J & FB may be  byte-size  values  that  assembly  will
promote to  words to make  them compatible with  the underlying function  call
requirements.  A1, A2 & AL are the addressing mode flags.



MACRO INVOCATION SYNTAX


strcat *S1,*S2,m1,m2

    Catenate string S2 to string S1.  m1 & m2 are the
    addressing modes, respectively, for *S1 & *S2.

strchr *S,*C,m1,m2

    Search string S for character C.  m1 & m2 are the
    addressing modes, respectively, for *S & *C.
    
strcmp *S1,*S2,m1,m2

    Compare string S2 to string S1 & return less than,
    equal to or greater than.  m1 & m2 are the add-
    ressing modes, respectively, for *S1 & *S2.

strdel *S,*I,*N,m1,m2,m3

    Delete N characters from string S, starting at
    index I.  m1, m2 & m3 are the addressing modes,
    respectively, for *S, *I & *N.

strins *S1,*S2,*I,m1,m2,m3

    Insert string S2 into string S1 at index I.  m1,
    m2 & m3 are the addressing modes, respectively,
    for *S1, *S2 & *I.

strlen *S,m

    Get number of bytes in string S.  m is the
    addressing mode for S.

strpad *S1,*S2,*L,m1,m2,m3,J,FB

    Copy string S2 to string S1.  S1 will be padded
    with character FB to length L & centered, left-
    justified or right-justified according to J.
    Recognized options for J are:

        0  S1 will be left-justified.
        1  S1 will be right-justified.
        2  S1 will be centered.

    Justification or centering is achieved with padding.
    m1, m2 & m3 are the addressing modes, respectively,
    for *S1, *S2 & *L.  J & FB are literal bytes.

strpat *S,*P,m1,m2

    Compare pattern P against string S, using wildcards &
    report a LIKE or UNLIKE result.  m1 & m2 are the add-
    ressing modes, respectively, for *S & *C.

strstr *S1,*S2,m1,m2

    Search string S1 for string S2.  m1 & m2 are the add-
    ressing modes, respectively, for *S1 & *S2.

strsub *S1,*S2,*I,*N,m1,m2,m3,m4

    Copy N bytes from string S2, starting at index I,
    into string S1.  m1, m2, m3 & m4 are the addressing
    modes, respectively, for *S1, *S2, *I & *N.

strsws *S,OP,m

    Strip whitespace from string S according to operation
    OP.  Recognized options for OP are:

        %10000000  Strip leading whitespace.
        %01000000  Strip trailing whitespace.
        %11000000  Strip leading & trailing whitespace.

    Whitespace is defined as blanks (ASCII $20) & tabs
    (ASCII $09).  m is the addressing mode for *S.  OP is
    a literal byte.
